using System;
using System.IO;
using System.Text;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using System.CodeDom;
using System.CodeDom.Compiler;
using Microsoft.CSharp;
using Microsoft.VisualBasic;

using SharpTools;
using SharpTools.DOM;

namespace CollectionBuilder
{
	/// <summary>
	/// Summary description for CollectionProperties.
	/// </summary>
	public class CollectionProperties : System.Windows.Forms.Form
	{

		#region Housekeeping 

		private System.Windows.Forms.Label lblDescription;
		private System.Windows.Forms.Button cmdCancel;
		private System.Windows.Forms.Button cmdOK;
		private System.Windows.Forms.GroupBox grpGeneralProperties;
		private System.Windows.Forms.Label lblCollectionNamespace;
		private System.Windows.Forms.TextBox txtCollectionNamespace;
		private System.Windows.Forms.TextBox txtCollectionName;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.GroupBox grpEvents;
		private System.Windows.Forms.CheckBox chkCreateEvents;
		private System.Windows.Forms.Label lblClassName;
		private System.Windows.Forms.ComboBox cboClassName;
		private System.Windows.Forms.RadioButton rdoEventsPublic;
		private System.Windows.Forms.RadioButton rdoEventsInternal;
		private System.Windows.Forms.RadioButton rdoCollectionInternal;
		private System.Windows.Forms.RadioButton rdoCollectionPublic;
//		private CollectionBuilder.ScopeControl scopeCollection;
//		private CollectionBuilder.ScopeControl scopeEvents;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public CollectionProperties()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if( components != null )
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lblDescription = new System.Windows.Forms.Label();
			this.cmdCancel = new System.Windows.Forms.Button();
			this.cmdOK = new System.Windows.Forms.Button();
			this.grpGeneralProperties = new System.Windows.Forms.GroupBox();
			this.lblClassName = new System.Windows.Forms.Label();
			this.cboClassName = new System.Windows.Forms.ComboBox();
			this.txtCollectionName = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.txtCollectionNamespace = new System.Windows.Forms.TextBox();
			this.lblCollectionNamespace = new System.Windows.Forms.Label();
			this.grpEvents = new System.Windows.Forms.GroupBox();
			this.chkCreateEvents = new System.Windows.Forms.CheckBox();
			this.rdoEventsPublic = new System.Windows.Forms.RadioButton();
			this.rdoEventsInternal = new System.Windows.Forms.RadioButton();
			this.rdoCollectionInternal = new System.Windows.Forms.RadioButton();
			this.rdoCollectionPublic = new System.Windows.Forms.RadioButton();
			this.grpGeneralProperties.SuspendLayout();
			this.grpEvents.SuspendLayout();
			this.SuspendLayout();
			// 
			// lblDescription
			// 
			this.lblDescription.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblDescription.Location = new System.Drawing.Point(12, 12);
			this.lblDescription.Name = "lblDescription";
			this.lblDescription.Size = new System.Drawing.Size(536, 40);
			this.lblDescription.TabIndex = 0;
			this.lblDescription.Text = "This plugin creates a strongly-typed collection from one of the classes in your c" +
				"urrent Visual Studio project.  Select or type the name of the class in the dropd" +
				"own below, and set the options you wish to use for this new collection.";
			// 
			// cmdCancel
			// 
			this.cmdCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdCancel.Location = new System.Drawing.Point(468, 432);
			this.cmdCancel.Name = "cmdCancel";
			this.cmdCancel.TabIndex = 13;
			this.cmdCancel.Text = "&Cancel";
			// 
			// cmdOK
			// 
			this.cmdOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.cmdOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.cmdOK.Location = new System.Drawing.Point(384, 432);
			this.cmdOK.Name = "cmdOK";
			this.cmdOK.TabIndex = 12;
			this.cmdOK.Text = "&Generate";
			this.cmdOK.Click += new System.EventHandler(this.cmdOK_Click);
			// 
			// grpGeneralProperties
			// 
			this.grpGeneralProperties.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.grpGeneralProperties.Controls.Add(this.rdoCollectionInternal);
			this.grpGeneralProperties.Controls.Add(this.rdoCollectionPublic);
			this.grpGeneralProperties.Controls.Add(this.lblClassName);
			this.grpGeneralProperties.Controls.Add(this.cboClassName);
			this.grpGeneralProperties.Controls.Add(this.txtCollectionName);
			this.grpGeneralProperties.Controls.Add(this.label1);
			this.grpGeneralProperties.Controls.Add(this.txtCollectionNamespace);
			this.grpGeneralProperties.Controls.Add(this.lblCollectionNamespace);
			this.grpGeneralProperties.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.grpGeneralProperties.Location = new System.Drawing.Point(12, 56);
			this.grpGeneralProperties.Name = "grpGeneralProperties";
			this.grpGeneralProperties.Size = new System.Drawing.Size(532, 140);
			this.grpGeneralProperties.TabIndex = 3;
			this.grpGeneralProperties.TabStop = false;
			this.grpGeneralProperties.Text = " General Collection Properties ";
			// 
			// lblClassName
			// 
			this.lblClassName.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblClassName.Location = new System.Drawing.Point(6, 16);
			this.lblClassName.Name = "lblClassName";
			this.lblClassName.Size = new System.Drawing.Size(188, 23);
			this.lblClassName.TabIndex = 8;
			this.lblClassName.Text = "Class to generate a collection for:";
			this.lblClassName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// cboClassName
			// 
			this.cboClassName.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.cboClassName.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboClassName.Location = new System.Drawing.Point(202, 16);
			this.cboClassName.Name = "cboClassName";
			this.cboClassName.Size = new System.Drawing.Size(324, 21);
			this.cboClassName.TabIndex = 9;
			this.cboClassName.SelectedIndexChanged += new System.EventHandler(this.cboClassName_SelectedIndexChanged);
			// 
			// txtCollectionName
			// 
			this.txtCollectionName.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtCollectionName.Location = new System.Drawing.Point(124, 68);
			this.txtCollectionName.Name = "txtCollectionName";
			this.txtCollectionName.Size = new System.Drawing.Size(400, 20);
			this.txtCollectionName.TabIndex = 7;
			this.txtCollectionName.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(12, 72);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(104, 16);
			this.label1.TabIndex = 6;
			this.label1.Text = "Name of collection:";
			// 
			// txtCollectionNamespace
			// 
			this.txtCollectionNamespace.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtCollectionNamespace.Location = new System.Drawing.Point(124, 44);
			this.txtCollectionNamespace.Name = "txtCollectionNamespace";
			this.txtCollectionNamespace.Size = new System.Drawing.Size(400, 20);
			this.txtCollectionNamespace.TabIndex = 5;
			this.txtCollectionNamespace.Text = "";
			// 
			// lblCollectionNamespace
			// 
			this.lblCollectionNamespace.Location = new System.Drawing.Point(12, 48);
			this.lblCollectionNamespace.Name = "lblCollectionNamespace";
			this.lblCollectionNamespace.Size = new System.Drawing.Size(104, 16);
			this.lblCollectionNamespace.TabIndex = 4;
			this.lblCollectionNamespace.Text = "Namespace:";
			// 
			// grpEvents
			// 
			this.grpEvents.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.grpEvents.Controls.Add(this.rdoEventsInternal);
			this.grpEvents.Controls.Add(this.rdoEventsPublic);
			this.grpEvents.Controls.Add(this.chkCreateEvents);
			this.grpEvents.Location = new System.Drawing.Point(12, 200);
			this.grpEvents.Name = "grpEvents";
			this.grpEvents.Size = new System.Drawing.Size(532, 88);
			this.grpEvents.TabIndex = 9;
			this.grpEvents.TabStop = false;
			this.grpEvents.Text = " Event Options";
			// 
			// chkCreateEvents
			// 
			this.chkCreateEvents.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.chkCreateEvents.Checked = true;
			this.chkCreateEvents.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkCreateEvents.Location = new System.Drawing.Point(8, 16);
			this.chkCreateEvents.Name = "chkCreateEvents";
			this.chkCreateEvents.Size = new System.Drawing.Size(520, 20);
			this.chkCreateEvents.TabIndex = 10;
			this.chkCreateEvents.Text = "Collection raises events ( such as when adding or removing items )";
			this.chkCreateEvents.CheckedChanged += new System.EventHandler(this.chkCreateEvents_CheckedChanged);
			// 
			// rdoEventsPublic
			// 
			this.rdoEventsPublic.Checked = true;
			this.rdoEventsPublic.Location = new System.Drawing.Point(8, 40);
			this.rdoEventsPublic.Name = "rdoEventsPublic";
			this.rdoEventsPublic.Size = new System.Drawing.Size(388, 20);
			this.rdoEventsPublic.TabIndex = 11;
			this.rdoEventsPublic.TabStop = true;
			this.rdoEventsPublic.Tag = "Public";
			this.rdoEventsPublic.Text = "Public accessibility";
			// 
			// rdoEventsInternal
			// 
			this.rdoEventsInternal.Location = new System.Drawing.Point(8, 64);
			this.rdoEventsInternal.Name = "rdoEventsInternal";
			this.rdoEventsInternal.Size = new System.Drawing.Size(388, 17);
			this.rdoEventsInternal.TabIndex = 12;
			this.rdoEventsInternal.Tag = "Internal";
			this.rdoEventsInternal.Text = "Internal, Friend, or Assembly accessibility";
			// 
			// rdoCollectionInternal
			// 
			this.rdoCollectionInternal.Location = new System.Drawing.Point(6, 116);
			this.rdoCollectionInternal.Name = "rdoCollectionInternal";
			this.rdoCollectionInternal.Size = new System.Drawing.Size(388, 17);
			this.rdoCollectionInternal.TabIndex = 14;
			this.rdoCollectionInternal.Tag = "Internal";
			this.rdoCollectionInternal.Text = "Internal, Friend, or Assembly accessibility";
			// 
			// rdoCollectionPublic
			// 
			this.rdoCollectionPublic.Checked = true;
			this.rdoCollectionPublic.Location = new System.Drawing.Point(6, 92);
			this.rdoCollectionPublic.Name = "rdoCollectionPublic";
			this.rdoCollectionPublic.Size = new System.Drawing.Size(388, 20);
			this.rdoCollectionPublic.TabIndex = 13;
			this.rdoCollectionPublic.TabStop = true;
			this.rdoCollectionPublic.Tag = "Public";
			this.rdoCollectionPublic.Text = "Public accessibility";
			// 
			// CollectionProperties
			// 
			this.AcceptButton = this.cmdOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdCancel;
			this.ClientSize = new System.Drawing.Size(556, 462);
			this.ControlBox = false;
			this.Controls.Add(this.grpEvents);
			this.Controls.Add(this.grpGeneralProperties);
			this.Controls.Add(this.cmdOK);
			this.Controls.Add(this.cmdCancel);
			this.Controls.Add(this.lblDescription);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.SizableToolWindow;
			this.Name = "CollectionProperties";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "SharpTools CollectionBuilder Plugin - Generate New Collection";
			this.Load += new System.EventHandler(this.CollectionProperties_Load);
			this.grpGeneralProperties.ResumeLayout(false);
			this.grpEvents.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#endregion 

		public static void ShowUI()
		{

			CollectionProperties dlg = new CollectionProperties();
			DialogResult result = dlg.ShowDialog();
			if( result != DialogResult.OK )
				return;

		}

		private void CollectionProperties_Load( object sender, System.EventArgs e )
		{

			ArrayList classes = ClassLocator.FindClasses();
			foreach( CodeElement element in classes )
				cboClassName.Items.Add( new GenerationTarget( element ) );

			if( cboClassName.Items.Count > 0 )
				cboClassName.SelectedIndex = 0;

		}

		private void cboClassName_SelectedIndexChanged( object sender, System.EventArgs e )
		{
		
			if( cboClassName.SelectedIndex == -1 )
				return;

			GenerationTarget element = ( GenerationTarget ) cboClassName.Items[ cboClassName.SelectedIndex ];
			txtCollectionName.Text = element.ClassName + "Collection";
			txtCollectionNamespace.Text = element.Namespace;

		}

		private void chkCreateEvents_CheckedChanged( object sender, System.EventArgs e )
		{
		
			rdoEventsPublic.Enabled = chkCreateEvents.Checked;
			rdoEventsInternal.Enabled = chkCreateEvents.Checked;

		}

		private MemberAttributes GetScope( params RadioButton[] buttons )
		{

			foreach( RadioButton button in buttons )
			{

				if( !button.Checked )
					continue;
				
				string tag = button.Tag.ToString().ToLower();

				if( tag == "public" )
					return MemberAttributes.Public;
				else if( tag == "internal" )
					return MemberAttributes.Assembly;

			}

			return MemberAttributes.Public;

		}

		private void cmdOK_Click( object sender, System.EventArgs e )
		{
		
			try
			{

				Project active = Globals.ActiveProject;

				string className = cboClassName.Text.Trim();
				string collectionName = txtCollectionName.Text.Trim();
				string collectionNamespace = txtCollectionNamespace.Text.Trim();

				if( className == "" || collectionName == "" || collectionNamespace == "" )
					return;

				string extension = Path.GetExtension( ((GenerationTarget) cboClassName.SelectedItem).CodeElement.ProjectItem.FileName );
				string fileName = collectionName + extension;

				ProjectItem newProjectItem = active.Find( fileName );
				if( newProjectItem != null )
				{
					
					DialogResult result = MessageBox.Show( fileName + " already exists in your project.  Do you wish to replace it?", "Duplicate Class Name", MessageBoxButtons.YesNo );
					if( result != DialogResult.Yes )
						return;

					if( newProjectItem.IsOpen( ViewMode.Any ) )
						newProjectItem.Document.Close( SaveMode.No );

				}

				MemberAttributes collectionScope = GetScope( rdoCollectionPublic, rdoCollectionInternal );
				CollectionBuilder builder = new CollectionBuilder( collectionName, collectionNamespace, className, collectionScope );

				if( chkCreateEvents.Checked )
					builder.AddEvents( GetScope( rdoEventsPublic, rdoEventsInternal ) );

				builder.AddCollectionMethods( GetScope( rdoCollectionPublic, rdoCollectionInternal ) );

				newProjectItem = active.ProjectItems.AddFromFileText( fileName, builder.GenerateCollectionClass(), true );
				System.Windows.Forms.Application.DoEvents();
				newProjectItem.Open( ViewMode.Primary );
				newProjectItem.CodeFile.Activate();

			}
			catch( Exception err )
			{
				Globals.PublishError( err );
			}

		}

		private class CollectionBuilder
		{

			#region Private member variables 

			private System.CodeDom.CodeNamespace	ns;
			private CodeTypeDeclaration				collection;
			private CodeDomProvider					provider;
			private ICodeGenerator					generator;
			private CodeGeneratorOptions			options;

			private string	className;
			private string	nameSpace;
			private string	classFullName;
			private string	itemFullName;
			private string	itemType;
			private string	itemNameSpace;
			private bool	eventsExist;

			#endregion

			#region Constructor 

			public CollectionBuilder( string ClassName, string NameSpace, string ItemType, MemberAttributes CollectionScope )
			{

				this.className = ClassName;
				this.nameSpace = NameSpace;
				this.classFullName = nameSpace + "." + className;
				this.eventsExist = false;

				int dotPos = ItemType.LastIndexOf( "." );
				this.itemNameSpace = ItemType.Substring( 0, dotPos );
				this.itemType = ItemType.Substring( dotPos + 1 );
				this.itemFullName = itemNameSpace + "." + itemType;

				provider = GetCodeDomProvider();
				generator = provider.CreateGenerator();
				options = new CodeGeneratorOptions();
				options.BlankLinesBetweenMembers = true;
				options.BracingStyle = "C";

				ns = new System.CodeDom.CodeNamespace( this.nameSpace );
				ns.Imports.Add( new CodeNamespaceImport( "System" ) );
				ns.Imports.Add( new CodeNamespaceImport( "System.Collections" ) );

				if( itemNameSpace != nameSpace )
					ns.Imports.Add( new CodeNamespaceImport( this.itemNameSpace ) );

				AddTypeDeclaration( CollectionScope );
				AddVariables();
				AddProperties();
				AddUtilityMethods();
				AddConstructor();
				AddIEnumerableMethods();
				AddCollectionMethods();

			}

			#endregion

			#region Public methods 

			public string GenerateCollectionClass()
			{

				StringBuilder buffer = new StringBuilder();
				IndentedTextWriter writer = new IndentedTextWriter( new StringWriter( buffer ) );

				generator.GenerateCodeFromNamespace( ns, writer, options );

				return buffer.ToString();

			}

			#endregion 

			#region Private utility methods 

			private CodeDomProvider GetCodeDomProvider()
			{

				Project active = Globals.ActiveProject;

				string extension = System.IO.Path.GetExtension( active.FileName ).ToLower();

				if( extension.EndsWith( "csproj" ) )
					return new CSharpCodeProvider();
				else if( extension.EndsWith( "vbproj" ) )
					return new VBCodeProvider();
				else
					throw new Exception( "Unsupported project type: " + extension );

			}

			private void AddTypeDeclaration( MemberAttributes scope )
			{

				collection = new CodeTypeDeclaration( this.className );
				collection.Attributes = MemberAttributes.Final;
				collection.IsClass = true;

				if( scope != MemberAttributes.Public )
				{
					collection.Attributes = MemberAttributes.FamilyAndAssembly;
					collection.TypeAttributes = System.Reflection.TypeAttributes.NotPublic;
				}

				ns.Types.Add( collection );

				// It turns out that the VBCodeProvider will not allow you to use the 
				// BaseTypes collection to indicate that your class implements an 
				// interface unless the class also inherits another class.  The VBCodeProvider
				// will see that this class inherits from Object, so any other types in 
				// the BaseTypes collection must be interfaces.
				// While I've tried hard to keep this thing language-agnostic, Microsoft
				// has not done as complete a job as necessary with this object model.
				if( provider is VBCodeProvider )
					collection.BaseTypes.Add( typeof(object) );

				collection.BaseTypes.Add( typeof(System.Collections.ICollection) );

				collection.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				collection.Comments.Add( new CodeCommentStatement( "Represents a collection of <see cref='" + itemFullName + "'/> objects.", true ) );
				collection.Comments.Add( new CodeCommentStatement( "</summary>", true ) );
				collection.Comments.Add( new CodeCommentStatement( "This class was created on " + DateTime.Today.ToShortDateString() + " by the SharpTools CollectionBuilder Addin.", false ) );

			}

			private void AddConstructor()
			{

				CodeConstructor constructor = new CodeConstructor() ;
				constructor.Attributes = MemberAttributes.Public ;
				constructor.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				constructor.Comments.Add( new CodeCommentStatement( "Initializes a new instance of the <see cref='" + classFullName + "'/> class.", true ) );
				constructor.Comments.Add( new CodeCommentStatement( "</summary>", true ) );

				constructor.Statements.Add( new CodeAssignStatement( new CodeVariableReferenceExpression( "items" ), new CodeObjectCreateExpression( typeof(System.Collections.ArrayList) ) ) );
				constructor.Statements.Add( new CodeAssignStatement( new CodeVariableReferenceExpression( "listVersion" ), new CodePrimitiveExpression( 0 ) ) );
				
				collection.Members.Add( constructor );
				
			
			}

			private void AddVariables()
			{

				CodeMemberField items = new CodeMemberField( typeof(System.Collections.ArrayList), "items" );
				items.Comments.Add( new CodeCommentStatement( "Provides the base object storage used by this class" ) );

				collection.Members.Add( items );
			}

			private void AddProperties()
			{

				CodeMemberField version = new CodeMemberField( typeof(System.Int32), "listVersion" );
				version.Comments.Add( new CodeCommentStatement( "This version counter is incremented any time the collection changes." ) );
				collection.Members.Add( version );

				CodeMemberProperty versionProperty = new CodeMemberProperty();
				versionProperty.Name = "Version";
				versionProperty.Type = new CodeTypeReference( typeof(System.Int32) );
				versionProperty.Attributes = MemberAttributes.Assembly;
				versionProperty.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				versionProperty.Comments.Add( new CodeCommentStatement( "Returns a number that can be used to determine if the collection has changed since some previous", true ) );
				versionProperty.Comments.Add( new CodeCommentStatement( "reference point, since this value changes each time the collection is modified in any way.", true ) );
				versionProperty.Comments.Add( new CodeCommentStatement( "</summary>", true ) );
				
				CodeMethodReturnStatement returnExpression = new CodeMethodReturnStatement();
				returnExpression.Expression = new CodeExpressionStatement( new CodeVariableReferenceExpression( "listVersion" ) ).Expression;

				versionProperty.GetStatements.Add( returnExpression );

				collection.Members.Add( versionProperty );

			}

			private void AddUtilityMethods()
			{

				CodeMemberMethod nextVersion = new CodeMemberMethod();
				nextVersion.Name = "IncrementVersion";
				nextVersion.Attributes = MemberAttributes.Private;
				nextVersion.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				nextVersion.Comments.Add( new CodeCommentStatement( "Internal method called whenever the collection changes to increment the Version property.", true ) );
				nextVersion.Comments.Add( new CodeCommentStatement( "</summary>", true ) );

				nextVersion.Statements.Add( 
					new CodeAssignStatement( 
					new CodeVariableReferenceExpression("listVersion"),
					new CodeBinaryOperatorExpression( new CodeVariableReferenceExpression("listVersion"), CodeBinaryOperatorType.Add, new CodePrimitiveExpression(1) )
					)
					);
				
				collection.Members.Add( nextVersion );

			}

			private CodeExpression CallIncrementVersion()
			{
				return new CodeMethodInvokeExpression( new CodeThisReferenceExpression(), "IncrementVersion" );
			}

			private CodeStatement CallClearEvent( string eventName )
			{

				if( !eventsExist )
					return new CodeCommentStatement( eventName );

				CodeEventReferenceExpression eventRef = new CodeEventReferenceExpression( new CodeThisReferenceExpression(), eventName );
				CodeDelegateInvokeExpression invoke = new CodeDelegateInvokeExpression( 
					eventRef, 
					new CodeThisReferenceExpression()
					);

				CodeBinaryOperatorExpression decision = new CodeBinaryOperatorExpression( 
					eventRef,
					CodeBinaryOperatorType.IdentityInequality, 
					new CodePrimitiveExpression( null ) 
					);

				CodeConditionStatement ifBlock = new CodeConditionStatement(
					decision,
					new CodeStatement[] { new CodeExpressionStatement(invoke) }
					);

				return ifBlock;

			}

			private CodeStatement CallChangedEvent( string eventName )
			{

				if( !eventsExist )
					return new CodeCommentStatement( eventName );

				CodeEventReferenceExpression eventRef = new CodeEventReferenceExpression( new CodeThisReferenceExpression(), eventName );
				CodeDelegateInvokeExpression invoke = new CodeDelegateInvokeExpression( 
					eventRef, 
					new CodeThisReferenceExpression(),
					new CodeArgumentReferenceExpression("value") 
					);

				CodeBinaryOperatorExpression decision = new CodeBinaryOperatorExpression( 
					eventRef,
					CodeBinaryOperatorType.IdentityInequality, 
					new CodePrimitiveExpression( null ) 
					);

				CodeConditionStatement ifBlock = new CodeConditionStatement(
					decision,
					new CodeStatement[] { new CodeExpressionStatement(invoke) }
					);

				return ifBlock;

			}

			#endregion 

			#region Generation of standard collection methods

			private void CreateAddMethod( MemberAttributes scope )
			{

				CodeMemberMethod method = new CodeMemberMethod();
				method.Parameters.Add( new CodeParameterDeclarationExpression( itemType, "value" ) );
				method.Name = "Add";
				method.ReturnType = new CodeTypeReference( "System.Int32" );
				method.Attributes = scope;

				method.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				method.Comments.Add( new CodeCommentStatement( "Adds the specified <see cref='" + itemFullName + "'/> to the <see cref='" + classFullName + "'/> collection.", true ) );
				method.Comments.Add( new CodeCommentStatement( "</summary>", true ) );
				method.Comments.Add( new CodeCommentStatement( "<returns>The position into which the new element was inserted.</returns>", true ) );

				method.Statements.Add( CallChangedEvent( "Inserting" ) );
				method.Statements.Add( CallIncrementVersion() );

				CodeVariableDeclarationStatement retVal = new CodeVariableDeclarationStatement( 
					typeof(System.Int32), 
					"retVal",
					new CodeMethodInvokeExpression( new CodeVariableReferenceExpression("items"), "Add", new CodeArgumentReferenceExpression( "value" ) )
					);

				method.Statements.Add( retVal );

				method.Statements.Add( CallChangedEvent( "InsertComplete" ) );

				CodeMethodReturnStatement returnExpression = new CodeMethodReturnStatement();
				returnExpression.Expression = new CodeVariableReferenceExpression( "retVal" );
				method.Statements.Add( returnExpression );

				collection.Members.Add( method );

			}

			private void CreateRemoveMethod( MemberAttributes scope )
			{

				CodeMemberMethod method = new CodeMemberMethod();
				method.Parameters.Add( new CodeParameterDeclarationExpression( itemType, "value" ) );
				method.Name = "Remove";
				method.Attributes = scope;

				method.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				method.Comments.Add( new CodeCommentStatement( "Removes the specified <see cref='" + itemFullName + "'/> from the <see cref='" + classFullName + "'/> collection.", true ) );
				method.Comments.Add( new CodeCommentStatement( "</summary>", true ) );

				method.Statements.Add( CallChangedEvent( "Removing" ) );
				method.Statements.Add( CallIncrementVersion() );

				CodeExpression expression = new CodeMethodInvokeExpression( new CodeVariableReferenceExpression("items"), "Remove", new CodeArgumentReferenceExpression( "value" ) );
				method.Statements.Add( expression );
			
				method.Statements.Add( CallChangedEvent( "RemoveComplete" ) );

				collection.Members.Add( method );

			}

			private void CreateRemoveAtMethod( MemberAttributes scope )
			{

				CodeMemberMethod method = new CodeMemberMethod();
				method.Parameters.Add( new CodeParameterDeclarationExpression( typeof(System.Int32), "index" ) );
				method.Name = "RemoveAt";
				method.Attributes = scope;

				method.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				method.Comments.Add( new CodeCommentStatement( "Removes the <see cref='" + itemFullName + "'/> object at the specified index from the <see cref='" + classFullName + "'/> collection.", true ) );
				method.Comments.Add( new CodeCommentStatement( "</summary>", true ) );

				CodeVariableDeclarationStatement obj = new CodeVariableDeclarationStatement(
					typeof(object), 
					"obj",
					new CodeIndexerExpression( new CodeVariableReferenceExpression( "items" ), new CodeArgumentReferenceExpression( "index" ) )
					);

				method.Statements.Add( obj );
			
				CodeMethodInvokeExpression invoke = new CodeMethodInvokeExpression(
					new CodeThisReferenceExpression(),
					"Remove",
					new CodeCastExpression( itemType, new CodeVariableReferenceExpression( "obj" ) )
					);

				method.Statements.Add( new CodeExpressionStatement( invoke ) );

				collection.Members.Add( method );

			}

			private void CreateInsertMethod( MemberAttributes scope )
			{

				CodeMemberMethod method = new CodeMemberMethod();
				method.Parameters.Add( new CodeParameterDeclarationExpression( typeof( int ), "index" ) );
				method.Parameters.Add( new CodeParameterDeclarationExpression( itemType, "value" ) );
				method.Name = "Insert";
				method.Attributes = scope;

				method.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				method.Comments.Add( new CodeCommentStatement( "Inserts a <see cref='" + itemFullName + "'/> object into the <see cref='" + classFullName + "'/> collection at the specified position.", true ) );
				method.Comments.Add( new CodeCommentStatement( "</summary>", true ) );
				method.Comments.Add( new CodeCommentStatement( "<param name='index'>The zero-based index at which value should be inserted.</param>", true ) );
				method.Comments.Add( new CodeCommentStatement( "<param name='value'>The " + itemFullName + " to insert into the <see cref='" + classFullName + "'/> collection.</param>", true ) );

				method.Statements.Add( CallChangedEvent( "Inserting" ) );
				method.Statements.Add( CallIncrementVersion() );

				CodeMethodInvokeExpression invoke = new CodeMethodInvokeExpression( new CodeVariableReferenceExpression("items"), "Insert", new CodeArgumentReferenceExpression( "index" ), new CodeArgumentReferenceExpression( "value" ) );
				method.Statements.Add( invoke );

				method.Statements.Add( CallChangedEvent( "InsertComplete" ) );
			
				collection.Members.Add( method );

			}

			private void CreateContainsMethod( MemberAttributes scope )
			{

				CodeMemberMethod method = new CodeMemberMethod();
				method.Parameters.Add( new CodeParameterDeclarationExpression( itemType, "value" ) );
				method.Name = "Contains";
				method.ReturnType = new CodeTypeReference( "System.Boolean" );
				method.Attributes = scope;

				method.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				method.Comments.Add( new CodeCommentStatement( "determines whether the <see cref='" + classFullName + "'/> collection contains a specific <see cref='" + itemFullName + "'/> object.", true ) );
				method.Comments.Add( new CodeCommentStatement( "</summary>", true ) );
				method.Comments.Add( new CodeCommentStatement( "<param name='value'>The " + itemFullName + " object to locate in the <see cref='" + classFullName + "'/> collection.</param>", true ) );
				method.Comments.Add( new CodeCommentStatement( "<returns>True if the System.Object is found in the collection; otherwise, False.</returns>", true ) );

				CodeMethodReturnStatement returnExpression = new CodeMethodReturnStatement();
				returnExpression.Expression = new CodeExpressionStatement( new CodeMethodInvokeExpression( new CodeVariableReferenceExpression("items"), "Contains", new CodeArgumentReferenceExpression( "value" ) ) ).Expression;
				method.Statements.Add( returnExpression );
			
				collection.Members.Add( method );

			}

			private void CreateIndexer( MemberAttributes scope )
			{

				CodeMemberProperty indexer = new CodeMemberProperty();
				indexer.Attributes = scope;
				indexer.Name = "Item";
				indexer.Type = new CodeTypeReference(itemType);
				indexer.Parameters.Add( new CodeParameterDeclarationExpression( typeof(int), "index" ) );

				indexer.GetStatements.Add(
					new CodeMethodReturnStatement(
						new CodeCastExpression(
							itemType,
								new CodeIndexerExpression(
									new CodePropertyReferenceExpression(new CodeThisReferenceExpression(), "items"),
										new CodeExpression[] {new CodeArgumentReferenceExpression("index")}
									)
							)
						)
					);

				indexer.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				indexer.Comments.Add( new CodeCommentStatement( "Returns the <see cref='" + itemFullName + "'/> at the specified index of the <see cref='" + classFullName + "'/>.", true ) );
				indexer.Comments.Add( new CodeCommentStatement( "</summary>", true ) );
				indexer.Comments.Add( new CodeCommentStatement( "<param name='index'>The zero-based index of the <see cref='" + itemFullName + "'/> to locate in the collection.</param>", true ) );
				indexer.Comments.Add( new CodeCommentStatement( "<returns> The <see cref='" + itemFullName + "'/> at the specified index of the collection.</returns>", true ) );
				indexer.Comments.Add( new CodeCommentStatement( "<exception cref='System.ArgumentOutOfRangeException'><paramref name='index'/> is outside the valid range of indexes for the collection.</exception>", true ) );

				collection.Members.Add( indexer );

			}

			private void CreateClearMethod( MemberAttributes scope )
			{

				CodeMemberMethod method = new CodeMemberMethod();
				method.Attributes = scope;
				method.Name = "Clear";

				method.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				method.Comments.Add( new CodeCommentStatement( "Removes all items from the collection.", true ) );
				method.Comments.Add( new CodeCommentStatement( "</summary>", true ) );

				method.Statements.Add( CallClearEvent( "Clearing" ) );
				method.Statements.Add( CallIncrementVersion() );

				CodeExpression expression = new CodeMethodInvokeExpression( new CodeVariableReferenceExpression("items"), "Clear" );
				method.Statements.Add( expression );
			
				method.Statements.Add( CallClearEvent( "ClearComplete" ) );

				collection.Members.Add( method );

			}

			public void CreateCloneMethod( MemberAttributes scope )
			{
			
				CodeMemberMethod method = new CodeMemberMethod();
				method.Attributes = scope;
				method.Name = "Clone";
				method.ReturnType = new CodeTypeReference( className );

				method.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				method.Comments.Add( new CodeCommentStatement( "Creates a shallow copy of the collection.", true ) );
				method.Comments.Add( new CodeCommentStatement( "</summary>", true ) );

				CodeVariableDeclarationStatement newObj = new CodeVariableDeclarationStatement( 
					className, 
					"obj", 
					new CodeObjectCreateExpression( className )
					);

				method.Statements.Add( newObj );

				CodeAssignStatement cloneItems = new CodeAssignStatement(
					new CodeFieldReferenceExpression( new CodeVariableReferenceExpression("obj"), "items" ),
					new CodeCastExpression( typeof(System.Collections.ArrayList), new CodeMethodInvokeExpression( new CodeVariableReferenceExpression( "items" ), "Clone" ) )
					);

				method.Statements.Add( cloneItems );

				CodeAssignStatement setVersion = new CodeAssignStatement( 
					new CodeFieldReferenceExpression( new CodeVariableReferenceExpression("obj"), "listVersion" ),
					new CodeFieldReferenceExpression( new CodeThisReferenceExpression(), "listVersion" )
					);

				method.Statements.Add( setVersion );

				method.Statements.Add( new CodeMethodReturnStatement( new CodeVariableReferenceExpression( "obj" ) ) );

				collection.Members.Add( method );

			}

			public void AddCollectionMethods( MemberAttributes scope )
			{

				CreateAddMethod( scope );
				CreateRemoveMethod( scope );
				CreateRemoveAtMethod( scope );
				CreateInsertMethod( scope );
				CreateIndexer( scope );
				CreateContainsMethod( scope );
				CreateClearMethod( scope );
				CreateCloneMethod( scope );

			}

			#endregion 

			#region IEnumerable method creation 

			private void AddIEnumerableMethods()
			{

				CodeMemberMethod getEnumerator = new CodeMemberMethod();
				getEnumerator.Name = "GetEnumerator";
				getEnumerator.ReturnType = new CodeTypeReference( "System.Collections.IEnumerator" );
				getEnumerator.Attributes = MemberAttributes.Public;
				getEnumerator.ImplementationTypes.Add( typeof(System.Collections.IEnumerable) );
				
				getEnumerator.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				getEnumerator.Comments.Add( new CodeCommentStatement( "Returns a <see cref='System.Collections.IEnumerator'/> object that can be used to enumerate", true ) );
				getEnumerator.Comments.Add( new CodeCommentStatement( "the entire collection.", true ) );
				getEnumerator.Comments.Add( new CodeCommentStatement( "</summary>", true ) );

				CodeMethodInvokeExpression invoke = new CodeMethodInvokeExpression(
					new CodeVariableReferenceExpression( "items" ),
					"GetEnumerator"
					);

				CodeMethodReturnStatement methodReturn = new CodeMethodReturnStatement( invoke );

				getEnumerator.Statements.Add( methodReturn );

				collection.Members.Add( getEnumerator );

			}

			#endregion 

			#region ICollection method creation 

			private void AddCopyToMethod()
			{

				CodeMemberMethod method = new CodeMemberMethod();
				method.Attributes = MemberAttributes.Public;
				method.Name = "CopyTo";
				method.Parameters.Add( new CodeParameterDeclarationExpression( typeof(System.Array), "array" ) );
				method.Parameters.Add( new CodeParameterDeclarationExpression( typeof(System.Int32), "index" ) );
				method.ImplementationTypes.Add( typeof(System.Collections.ICollection) );

				method.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				method.Comments.Add( new CodeCommentStatement( "Copies the elements of this " + classFullName + " to a System.Array, starting at a particular System.Array index.", true ) );
				method.Comments.Add( new CodeCommentStatement( "<summary>", true ) );

				CodeExpression expression = new CodeMethodInvokeExpression( new CodeVariableReferenceExpression("items"), "CopyTo", new CodeArgumentReferenceExpression( "array" ), new CodeArgumentReferenceExpression( "index" ) );
				method.Statements.Add( expression );
			
				collection.Members.Add( method );

			}

			private void AddCountProperty()
			{

				CodeMemberProperty property = new CodeMemberProperty();
				property.Attributes = MemberAttributes.Public;
				property.Name = "Count";
				property.Type = new CodeTypeReference( typeof(int) );
				property.ImplementationTypes.Add( typeof(System.Collections.ICollection) );

				property.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				property.Comments.Add( new CodeCommentStatement( "Gets the number objects contained in the collection.", true ) );
				property.Comments.Add( new CodeCommentStatement( "<summary>", true ) );

				CodeMethodReturnStatement methodReturn = new CodeMethodReturnStatement( new CodePropertyReferenceExpression( new CodeVariableReferenceExpression("items"), "Count" ) );
				property.GetStatements.Add( methodReturn );

				collection.Members.Add( property );

			}

			private void AddIsSynchronizedProperty()
			{

				CodeMemberProperty property = new CodeMemberProperty();
				property.Attributes = MemberAttributes.Public;
				property.Name = "IsSynchronized";
				property.Type = new CodeTypeReference( typeof(bool) );
				property.ImplementationTypes.Add( typeof(System.Collections.ICollection) );

				property.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				property.Comments.Add( new CodeCommentStatement( "Gets a value indicating whether access to the collection is synchronized (thread-safe).", true ) );
				property.Comments.Add( new CodeCommentStatement( "<summary>", true ) );

				CodeMethodReturnStatement methodReturn = new CodeMethodReturnStatement( new CodePropertyReferenceExpression( new CodeVariableReferenceExpression("items"), "IsSynchronized" ) );
				property.GetStatements.Add( methodReturn );

				collection.Members.Add( property );

			}

			private void AddSyncRootProperty()
			{
			
				CodeMemberProperty property = new CodeMemberProperty();
				property.Attributes = MemberAttributes.Public;
				property.Name = "SyncRoot";
				property.Type = new CodeTypeReference( typeof(object) );
				property.ImplementationTypes.Add( typeof(System.Collections.ICollection) );

				property.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				property.Comments.Add( new CodeCommentStatement( "Gets an object that can be used to synchronize access to the collection.", true ) );
				property.Comments.Add( new CodeCommentStatement( "<summary>", true ) );

				CodeMethodReturnStatement methodReturn = new CodeMethodReturnStatement( new CodePropertyReferenceExpression( new CodeVariableReferenceExpression("items"), "SyncRoot" ) );
				property.GetStatements.Add( methodReturn );

				collection.Members.Add( property );

			}

			private void AddCollectionMethods()
			{
				AddCopyToMethod();
				AddCountProperty();
				AddIsSynchronizedProperty();
				AddSyncRootProperty();
			}

			#endregion 

			#region Generation of events 

			private CodeMemberEvent AddEventDeclaration( MemberAttributes scope, CodeTypeReference eventType, string eventName, string comment )
			{

				CodeMemberEvent newEvent = new CodeMemberEvent();
				newEvent.Name = eventName;
				newEvent.Attributes = scope;
				newEvent.Type = eventType;
				newEvent.Attributes = scope;

				newEvent.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				newEvent.Comments.Add( new CodeCommentStatement( comment, true ) );
				newEvent.Comments.Add( new CodeCommentStatement( "</summary>", true ) );
				
				collection.Members.Add( newEvent );

				return newEvent;

			}

			public void AddEvents( MemberAttributes scope )
			{

				eventsExist = true;

				// Strange behavior here...  No matter what value the Attributes property is set to on a 
				// CodeTypeDelegate object, the rendered code is Public.
				CodeTypeDelegate collectionChanged = new CodeTypeDelegate( className + "ChangedEventHandler" );
				collectionChanged.Parameters.Add( new CodeParameterDeclarationExpression( typeof(object), "sender" ) );
				collectionChanged.Parameters.Add( new CodeParameterDeclarationExpression( itemType, "value" ) );
				collectionChanged.Attributes = scope;

				collectionChanged.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				collectionChanged.Comments.Add( new CodeCommentStatement( "Defines the type of event that is called whenever a new object is inserted into or removed from the " + classFullName + " collection.", true ) );
				collectionChanged.Comments.Add( new CodeCommentStatement( "</summary>", true ) );

				collection.Members.Add( collectionChanged );

				// Strange behavior here...  No matter what value the Attributes property is set to on a 
				// CodeTypeDelegate object, the rendered code is Public.
				CodeTypeDelegate collectionCleared = new CodeTypeDelegate( className + "ClearedEventHandler" );
				collectionCleared.Parameters.Add( new CodeParameterDeclarationExpression( typeof(object), "sender" ) );
				collectionCleared.Attributes = scope;

				collectionCleared.Comments.Add( new CodeCommentStatement( "<summary>", true ) );
				collectionCleared.Comments.Add( new CodeCommentStatement( "Defines the type of event that is called whenever the collection is cleared.", true ) );
				collectionCleared.Comments.Add( new CodeCommentStatement( "</summary>", true ) );

				collection.Members.Add( collectionCleared );

				CodeTypeReference changedTypeRef = new CodeTypeReference( collectionChanged.Name );
				CodeTypeReference clearedTypeRef = new CodeTypeReference( collectionCleared.Name );

				AddEventDeclaration( scope, changedTypeRef, "Inserting", "Called when an object is being inserted into the collection." );
				AddEventDeclaration( scope, changedTypeRef, "InsertComplete", "Called after an object has been inserted into the collection." );
				AddEventDeclaration( scope, changedTypeRef, "Removing", "Called when an object is being removed from the collection." );
				AddEventDeclaration( scope, changedTypeRef, "RemoveComplete", "Called after an object has been removed from the collection." );
				AddEventDeclaration( scope, clearedTypeRef, "Clearing", "Called when the collection is being cleared." );
				AddEventDeclaration( scope, clearedTypeRef, "ClearComplete", "Called after the collection has been cleared." );

			}

			#endregion 

		}

		#region GenerationTarget private class 

		private class GenerationTarget
		{

			public readonly string		ClassName;
			public readonly string		Namespace;
			public readonly CodeElement CodeElement;

			public GenerationTarget( CodeElement element )
			{

				this.CodeElement = element;
				
				string fullName = element.FullName;
				int dotPos = fullName.LastIndexOf( "." );
				if( dotPos != -1 )
				{
					Namespace = fullName.Substring( 0, dotPos );
					ClassName = fullName.Substring( dotPos + 1 );
				}
				else
				{
					Namespace = Globals.ActiveProject.DefaultNamespace;
					ClassName = fullName;
				}

			}

			public override string ToString()
			{
				return CodeElement.FullName;
			}

		}

		#endregion 

	}

}
