using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using RSSReader.OPML;
using RSSReader.RSS;

namespace RSSReader
{
	/// <summary>
	/// Summary description for FeedProperties.
	/// </summary>
	public class FeedProperties : System.Windows.Forms.Form
	{

		#region 

		private System.Windows.Forms.Button Cancel;
		private System.Windows.Forms.Button OK;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox Title;
		private System.Windows.Forms.TextBox XmlUrl;
		private RSSReaderPlugin.Controls.TimespanDropdown RefreshRate;
		private RSSReaderPlugin.Controls.TimespanDropdown MaxItemAge;
		private System.Windows.Forms.NumericUpDown MaxItemCount;
		private System.Windows.Forms.CheckBox chkAlertNewItems;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FeedProperties()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Cancel = new System.Windows.Forms.Button();
			this.OK = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.Title = new System.Windows.Forms.TextBox();
			this.XmlUrl = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.RefreshRate = new RSSReaderPlugin.Controls.TimespanDropdown();
			this.label4 = new System.Windows.Forms.Label();
			this.MaxItemAge = new RSSReaderPlugin.Controls.TimespanDropdown();
			this.label5 = new System.Windows.Forms.Label();
			this.MaxItemCount = new System.Windows.Forms.NumericUpDown();
			this.chkAlertNewItems = new System.Windows.Forms.CheckBox();
			((System.ComponentModel.ISupportInitialize)(this.MaxItemCount)).BeginInit();
			this.SuspendLayout();
			// 
			// Cancel
			// 
			this.Cancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.Cancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.Cancel.Location = new System.Drawing.Point(322, 198);
			this.Cancel.Name = "Cancel";
			this.Cancel.TabIndex = 7;
			this.Cancel.Text = "&Cancel";
			// 
			// OK
			// 
			this.OK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.OK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.OK.Location = new System.Drawing.Point(238, 198);
			this.OK.Name = "OK";
			this.OK.TabIndex = 6;
			this.OK.Text = "&OK";
			this.OK.Click += new System.EventHandler(this.OK_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 20);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(106, 18);
			this.label1.TabIndex = 8;
			this.label1.Text = "Title:";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Title
			// 
			this.Title.Location = new System.Drawing.Point(120, 18);
			this.Title.Name = "Title";
			this.Title.Size = new System.Drawing.Size(274, 20);
			this.Title.TabIndex = 9;
			this.Title.Text = "";
			// 
			// XmlUrl
			// 
			this.XmlUrl.Location = new System.Drawing.Point(120, 44);
			this.XmlUrl.Name = "XmlUrl";
			this.XmlUrl.Size = new System.Drawing.Size(274, 20);
			this.XmlUrl.TabIndex = 11;
			this.XmlUrl.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 46);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(106, 18);
			this.label2.TabIndex = 10;
			this.label2.Text = "Url:";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 72);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(106, 20);
			this.label3.TabIndex = 12;
			this.label3.Text = "Refresh Every:";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// RefreshRate
			// 
			this.RefreshRate.Location = new System.Drawing.Point(120, 70);
			this.RefreshRate.Name = "RefreshRate";
			this.RefreshRate.SelectedValue = System.TimeSpan.Parse("00:15:00");
			this.RefreshRate.Size = new System.Drawing.Size(121, 21);
			this.RefreshRate.TabIndex = 13;
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 100);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(106, 20);
			this.label4.TabIndex = 14;
			this.label4.Text = "Max Item Age:";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// MaxItemAge
			// 
			this.MaxItemAge.Location = new System.Drawing.Point(120, 98);
			this.MaxItemAge.Name = "MaxItemAge";
			this.MaxItemAge.SelectedValue = System.TimeSpan.Parse("00:15:00");
			this.MaxItemAge.Size = new System.Drawing.Size(121, 21);
			this.MaxItemAge.TabIndex = 15;
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 128);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(106, 20);
			this.label5.TabIndex = 16;
			this.label5.Text = "Max Item Count:";
			this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// MaxItemCount
			// 
			this.MaxItemCount.Increment = new System.Decimal(new int[] {
																		   10,
																		   0,
																		   0,
																		   0});
			this.MaxItemCount.Location = new System.Drawing.Point(120, 126);
			this.MaxItemCount.Maximum = new System.Decimal(new int[] {
																		 1000,
																		 0,
																		 0,
																		 0});
			this.MaxItemCount.Minimum = new System.Decimal(new int[] {
																		 1,
																		 0,
																		 0,
																		 0});
			this.MaxItemCount.Name = "MaxItemCount";
			this.MaxItemCount.Size = new System.Drawing.Size(122, 20);
			this.MaxItemCount.TabIndex = 17;
			this.MaxItemCount.Value = new System.Decimal(new int[] {
																	   1,
																	   0,
																	   0,
																	   0});
			// 
			// chkAlertNewItems
			// 
			this.chkAlertNewItems.Location = new System.Drawing.Point(120, 152);
			this.chkAlertNewItems.Name = "chkAlertNewItems";
			this.chkAlertNewItems.Size = new System.Drawing.Size(278, 16);
			this.chkAlertNewItems.TabIndex = 18;
			this.chkAlertNewItems.Text = "Show popup alert when new items are received";
			// 
			// FeedProperties
			// 
			this.AcceptButton = this.OK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.Cancel;
			this.ClientSize = new System.Drawing.Size(406, 228);
			this.ControlBox = false;
			this.Controls.Add(this.chkAlertNewItems);
			this.Controls.Add(this.MaxItemCount);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.MaxItemAge);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.RefreshRate);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.XmlUrl);
			this.Controls.Add(this.Title);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.Cancel);
			this.Controls.Add(this.OK);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Name = "FeedProperties";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Edit RSS Feed Properties";
			this.Load += new System.EventHandler(this.FeedProperties_Load);
			((System.ComponentModel.ISupportInitialize)(this.MaxItemCount)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#endregion 

		#region Public static members 

		public static DialogResult EditFeed( OPMLItemNode Subscription )
		{

			RSSFeed feed = FeedManager.GetCachedFeed( Subscription.XmlUrl );
			if( feed == null )
				feed = FeedManager.RetrieveFeed( Subscription.XmlUrl );

			if( feed == null )
			{
				MessageBox.Show( "Error editing feed properties: Failed to retrieve feed information", "RSSReader" );
				return DialogResult.Cancel;
			}

			FeedProperties dlg = new FeedProperties();
			dlg.subscription = Subscription;
			dlg.feed = feed;
			
			DialogResult result = dlg.ShowDialog();
			if( result != DialogResult.OK )
				return DialogResult.Cancel;

			FeedManager.SaveFeed( dlg.feed );

			return DialogResult.OK;

		}

		#endregion 

		#region Private variables 

		private OPMLItemNode	subscription;
		private RSSFeed			feed;

		#endregion 

		private void FeedProperties_Load(object sender, System.EventArgs e)
		{

			Title.Text = subscription.Title;
			XmlUrl.Text = feed.XmlUrl;
			RefreshRate.SelectedValue = feed.RefreshRate;
			MaxItemAge.SelectedValue = feed.MaxItemAge;
			MaxItemCount.Value = feed.MaxItemCount;
			chkAlertNewItems.Checked = feed.AlertOnNewItems;

		}

		private void OK_Click(object sender, System.EventArgs e)
		{
		
			subscription.Title = Title.Text.Trim();
			subscription.XmlUrl = XmlUrl.Text.Trim();
			feed.XmlUrl = XmlUrl.Text.Trim();
			feed.RefreshRate = RefreshRate.SelectedValue;
			feed.MaxItemAge = MaxItemAge.SelectedValue;
			feed.MaxItemCount = (int) MaxItemCount.Value;
			feed.AlertOnNewItems = chkAlertNewItems.Checked;

		}

	}

}
