using System;
using System.IO;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace ScreenCapture
{
	/// <summary>
	/// Summary description for Captures.
	/// </summary>
	public class Captures : System.Windows.Forms.UserControl
	{

		#region 

		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ToolBarButton tbSave;
		private System.Windows.Forms.TabControl Tabs;
		private System.Windows.Forms.ToolBarButton tbClose;
		private System.ComponentModel.IContainer components;

		public Captures()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Captures));
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.tbSave = new System.Windows.Forms.ToolBarButton();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.Tabs = new System.Windows.Forms.TabControl();
			this.tbClose = new System.Windows.Forms.ToolBarButton();
			this.SuspendLayout();
			// 
			// toolBar1
			// 
			this.toolBar1.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.toolBar1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.tbSave,
																						this.tbClose});
			this.toolBar1.ButtonSize = new System.Drawing.Size(16, 16);
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.ImageList = this.imageList1;
			this.toolBar1.Location = new System.Drawing.Point(0, 0);
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(408, 29);
			this.toolBar1.TabIndex = 0;
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
			// 
			// tbSave
			// 
			this.tbSave.Enabled = false;
			this.tbSave.ImageIndex = 0;
			this.tbSave.ToolTipText = "Save This Image";
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// Tabs
			// 
			this.Tabs.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.Tabs.Location = new System.Drawing.Point(0, 32);
			this.Tabs.Name = "Tabs";
			this.Tabs.SelectedIndex = 0;
			this.Tabs.Size = new System.Drawing.Size(408, 320);
			this.Tabs.TabIndex = 1;
			// 
			// tbClose
			// 
			this.tbClose.Enabled = false;
			this.tbClose.ImageIndex = 1;
			this.tbClose.ToolTipText = "Close this image tab";
			// 
			// Captures
			// 
			this.Controls.Add(this.Tabs);
			this.Controls.Add(this.toolBar1);
			this.Name = "Captures";
			this.Size = new System.Drawing.Size(408, 352);
			this.ResumeLayout(false);

		}
		#endregion

		#endregion 

		private int captureCounter = 0;

		private void SetToolbarEnabled()
		{
			tbSave.Enabled = Tabs.TabCount > 0;
			tbClose.Enabled = Tabs.TabCount > 0;
		}

		public void AddCapture( Image image )
		{

			captureCounter += 1;
			string filename = "Untitled" + captureCounter;

			TabPage page = new TabPage( filename );
			CaptureContainer container = new CaptureContainer( image, filename );
			page.Controls.Add( container );
			container.Dock = DockStyle.Fill;

			Tabs.TabPages.Add( page );
			Tabs.SelectedTab = page;

			SetToolbarEnabled();

		}

		private void SaveSelectedImage()
		{

			TabPage page = Tabs.SelectedTab;
			CaptureContainer capture = (CaptureContainer) page.Controls[0];
			capture.SaveAs();
			page.Text = Path.GetFileName( capture.Filename );

		}

		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{

			if( e.Button == tbClose )
			{
				Tabs.TabPages.RemoveAt( Tabs.SelectedIndex );
				SetToolbarEnabled();
				return;
			}

			if( e.Button == tbSave )
				SaveSelectedImage();

		}

	}

}
